Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -3694,96 +3694,74 @@
 
 
-       CHARACTER (LEN = *), INTENT(IN)    ::  sk_char !< string identifier, used for assign fluxes to the correct dimension in the analysis array 
-       INTEGER(iwp) ::  sk_num !< integer identifier, used for assign fluxes to the correct dimension in the analysis array
-       
-       INTEGER(iwp) ::  i          !< grid index along x-direction
-       INTEGER(iwp) ::  j          !< grid index along y-direction
-       INTEGER(iwp) ::  k          !< grid index along z-direction
-       INTEGER(iwp) ::  k_mm       !< k-2 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  k_pp       !< k+2 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  k_ppp      !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l  !< index indicating upper bound for order degradation of horizontal advection terms 
-       INTEGER(iwp) ::  tn = 0     !< number of OpenMP thread
-       
+       CHARACTER (LEN = *), INTENT(IN) ::  sk_char !< string identifier, used for assign fluxes
+                                                   !< to the correct dimension in the analysis array
+
+       INTEGER(iwp) ::  i         !< grid index along x-direction
+       INTEGER(iwp) ::  j         !< grid index along y-direction
+       INTEGER(iwp) ::  k         !< grid index along z-direction
+       INTEGER(iwp) ::  k_mm      !< k-2 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms
+       INTEGER(iwp) ::  sk_num    !< integer identifier, used for assign fluxes to the correct dimension in the analysis array
+       INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
+
        INTEGER(iwp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::   &
                                                   advc_flag !< flag array to control order of scalar advection
-                                                  
-       LOGICAL ::  non_cyclic_l    !< flag that indicates non-cyclic boundary on the left
-       LOGICAL ::  non_cyclic_n    !< flag that indicates non-cyclic boundary on the north
-       LOGICAL ::  non_cyclic_r    !< flag that indicates non-cyclic boundary on the right
-       LOGICAL ::  non_cyclic_s    !< flag that indicates non-cyclic boundary on the south  
-!       
-!--    sk is an array from parameter list. It should not be a pointer, because 
-!--    in that case the compiler can not assume a stride 1 and cannot perform 
-!--    a strided one vector load. Adding the CONTIGUOUS keyword makes things 
-!--    even worse, because the compiler cannot assume strided one in the 
-!--    caller side.
-       REAL(wp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
-
-       REAL(wp) ::  ibit0  !< flag indicating 1st-order scheme along x-direction
-       REAL(wp) ::  ibit1  !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp) ::  ibit2  !< flag indicating 5th-order scheme along x-direction
+
+       LOGICAL  ::  non_cyclic_l    !< flag that indicates non-cyclic boundary on the left
+       LOGICAL  ::  non_cyclic_n    !< flag that indicates non-cyclic boundary on the north
+       LOGICAL  ::  non_cyclic_r    !< flag that indicates non-cyclic boundary on the right
+       LOGICAL  ::  non_cyclic_s    !< flag that indicates non-cyclic boundary on the south
+
+       REAL(wp) ::  diss_d        !< artificial dissipation term at grid box bottom
+       REAL(wp) ::  div           !< velocity diverence on scalar grid
+       REAL(wp) ::  flux_d        !< 6th-order flux at grid box bottom
+       REAL(wp) ::  ibit0         !< flag indicating 1st-order scheme along x-direction
+       REAL(wp) ::  ibit1         !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp) ::  ibit2         !< flag indicating 5th-order scheme along x-direction
+       REAL(wp) ::  ibit3         !< flag indicating 1st-order scheme along y-direction
+       REAL(wp) ::  ibit4         !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp) ::  ibit5         !< flag indicating 5th-order scheme along y-direction
+       REAL(wp) ::  ibit6         !< flag indicating 1st-order scheme along z-direction
+       REAL(wp) ::  ibit7         !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp) ::  ibit8         !< flag indicating 5th-order scheme along z-direction
 #ifdef _OPENACC
        REAL(wp) ::  ibit0_l  !< flag indicating 1st-order scheme along x-direction
        REAL(wp) ::  ibit1_l  !< flag indicating 3rd-order scheme along x-direction
        REAL(wp) ::  ibit2_l  !< flag indicating 5th-order scheme along x-direction
-#endif
-       REAL(wp) ::  ibit3  !< flag indicating 1st-order scheme along y-direction
-       REAL(wp) ::  ibit4  !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp) ::  ibit5  !< flag indicating 5th-order scheme along y-direction
-#ifdef _OPENACC
        REAL(wp) ::  ibit3_s  !< flag indicating 1st-order scheme along y-direction
        REAL(wp) ::  ibit4_s  !< flag indicating 3rd-order scheme along y-direction
        REAL(wp) ::  ibit5_s  !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp) ::  ibit6  !< flag indicating 1st-order scheme along z-direction
-       REAL(wp) ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp) ::  ibit8  !< flag indicating 5th-order scheme along z-direction
-       REAL(wp) ::  diss_d !< artificial dissipation term at grid box bottom 
-       REAL(wp) ::  div    !< diverence on scalar grid
-       REAL(wp) ::  flux_d !< 6th-order flux at grid box bottom
-       REAL(wp) ::  u_comp !< advection velocity along x-direction
+       REAL(wp) ::  u_comp        !< advection velocity along x-direction
+       REAL(wp) ::  v_comp        !< advection velocity along y-direction
 #ifdef _OPENACC
        REAL(wp) ::  u_comp_l !< advection velocity along x-direction
-#endif
-       REAL(wp) ::  v_comp !< advection velocity along y-direction
-#ifdef _OPENACC
        REAL(wp) ::  v_comp_s !< advection velocity along y-direction
 #endif
-       
-       REAL(wp) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp) ::  diss_t !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp) ::  flux_t !< discretized 6th-order flux at rightward-side of the grid box
-       
-       REAL(wp) ::  diss_s !< discretized artificial dissipation term at southward-side of the grid box
-       REAL(wp) ::  flux_s !< discretized 6th-order flux at northward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local !< discretized artificial dissipation term at southward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local !< discretized 6th-order flux at northward-side of the grid box
-#endif
-       
-       REAL(wp) ::  diss_l !< discretized artificial dissipation term at leftward-side of the grid box
-       REAL(wp) ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local !< discretized artificial dissipation term at leftward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local !< discretized 6th-order flux at leftward-side of the grid box
-#endif
-        
-!
-!--    Set local version of nzb_max. At non-cyclic boundaries the order of the 
-!--    advection need to be degraded near the boundary. Please note, in contrast
-!--    to the cache-optimized routines, nzb_max_l is set constantly for the 
-!--    entire subdomain, in order to avoid unsymmetric loops which might be 
-!--    an issue for GPUs.
-       IF( non_cyclic_l  .OR.  non_cyclic_r  .OR.                             &
-           non_cyclic_s  .OR.  non_cyclic_n )  THEN
-          nzb_max_l = nzt
-       ELSE
-          nzb_max_l = nzb_max
-       END IF 
-        
+!
+!--    sk is an array from parameter list. It should not be a pointer, because
+!--    in that case the compiler can not assume a stride 1 and cannot perform
+!--    a strided one vector load. Adding the CONTIGUOUS keyword makes things
+!--    even worse, because the compiler cannot assume strided one in the
+!--    caller side.
+       REAL(wp), INTENT(IN),DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
+
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_n     !< discretized artificial dissipation at northward-side
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_r     !< discretized artificial dissipation at rightward-side
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_t     !< discretized artificial dissipation at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_n     !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_r     !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1)         ::  flux_t     !< discretized 6th-order flux at top of the grid box
+
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  swap_diss_y_local !< discretized artificial dissipation at southward-side
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  swap_flux_y_local !< discretized 6th-order flux at northward-side
+
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  swap_diss_x_local !< discretized artificial dissipation at leftward-side
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  swap_flux_x_local !< discretized 6th-order flux at leftward-side
+
+       CALL cpu_log( log_point_s(49), 'advec_s_ws', 'start' )
+
        SELECT CASE ( sk_char )
 
@@ -3811,69 +3789,4 @@
        END SELECT
 
-#ifndef _OPENACC
-!
-!--    Compute the fluxes for the whole left boundary of the processor domain.
-       i = nxl
-       DO  j = nys, nyn
-
-          DO  k = nzb+1, nzb_max_l
-
-             ibit2 = REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )
-             ibit1 = REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )
-             ibit0 = REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )
-
-             u_comp                 = u(k,j,i) - u_gtrans + u_stokes_zu(k)
-             swap_flux_x_local(k,j) = u_comp * (                              &
-                                             ( 37.0_wp * ibit2 * adv_sca_5    &
-                                          +     7.0_wp * ibit1 * adv_sca_3    &
-                                          +              ibit0 * adv_sca_1    &
-                                             ) *                              &
-                                          ( sk(k,j,i)   + sk(k,j,i-1)    )    &
-                                      -      (  8.0_wp * ibit2 * adv_sca_5    &
-                                          +              ibit1 * adv_sca_3    &
-                                             ) *                              &
-                                          ( sk(k,j,i+1) + sk(k,j,i-2)    )    &
-                                      +      (           ibit2 * adv_sca_5    & 
-                                             ) *                              &
-                                          ( sk(k,j,i+2) + sk(k,j,i-3)    )    &
-                                               )
-
-              swap_diss_x_local(k,j) = -ABS( u_comp ) * (                     &
-                                             ( 10.0_wp * ibit2 * adv_sca_5    &
-                                          +     3.0_wp * ibit1 * adv_sca_3    &
-                                          +              ibit0 * adv_sca_1    &
-                                             ) *                              &
-                                          ( sk(k,j,i)   - sk(k,j,i-1) )       &
-                                      -      (  5.0_wp * ibit2 * adv_sca_5    &
-                                          +              ibit1 * adv_sca_3    &
-                                             ) *                              &
-                                         ( sk(k,j,i+1) - sk(k,j,i-2)  )       &
-                                      +      (           ibit2 * adv_sca_5    &
-                                             ) *                              &
-                                          ( sk(k,j,i+2) - sk(k,j,i-3) )       &
-                                                        )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
-
-             u_comp                 = u(k,j,i) - u_gtrans + u_stokes_zu(k)
-             swap_flux_x_local(k,j) = u_comp * (                              &
-                                      37.0_wp * ( sk(k,j,i)   + sk(k,j,i-1) ) &
-                                    -  8.0_wp * ( sk(k,j,i+1) + sk(k,j,i-2) ) &
-                                    +           ( sk(k,j,i+2) + sk(k,j,i-3) ) &
-                                               ) * adv_sca_5
-
-             swap_diss_x_local(k,j) = -ABS( u_comp ) * (                      &
-                                      10.0_wp * ( sk(k,j,i)   - sk(k,j,i-1) ) &
-                                    -  5.0_wp * ( sk(k,j,i+1) - sk(k,j,i-2) ) &
-                                    +           ( sk(k,j,i+2) - sk(k,j,i-3) ) &
-                                                       ) * adv_sca_5
-
-          ENDDO
-
-       ENDDO
-#endif
-
        !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, sk_num) &
        !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
@@ -3882,6 +3795,7 @@
        !$ACC PRIVATE(ibit3_s, ibit4_s, ibit5_s) &
        !$ACC PRIVATE(ibit6, ibit7, ibit8) &
-       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
-       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_r, diss_r) &
+       !$ACC PRIVATE(flux_n, diss_n) &
+       !$ACC PRIVATE(swap_diss_y_local, swap_flux_y_local) &
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s) &
@@ -3890,5 +3804,5 @@
        !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
        !$ACC PRESENT(tend) &
-       !$ACC PRESENT(hom(nzb+1:nzb_max_l,1,1:3,0)) &
+       !$ACC PRESENT(hom(:,1,1:3,0)) &
        !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
        !$ACC PRESENT(sums_wspts_ws_l, sums_wssas_ws_l) &
